<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use DB;

class AdminController extends Controller
{
	public function AddRateCartApi(Request $req){ 
		$exam_id = isset($req['exam_id'])?$req['exam_id']:'';
		$book_id = isset($req['book_id'])?$req['book_id']:'';
		$mrp = isset($req['mrp'])?$req['mrp']:'';
		$min_qty = isset($req['min_qty'])?$req['min_qty']:'';
		$max_qty = isset($req['max_qty'])?$req['max_qty']:'';
		$bulk_price = isset($req['bulk_price'])?$req['bulk_price']:'';
		$discount = isset($req['discount'])?$req['discount']:'';
		$discount_percentage = isset($req['discount_percent'])?$req['discount_percent']:'';
	    date_default_timezone_set('asia/kolkata');
        $ts = date('y-m-d h:i:s');
		try{ 
			 
			$rate_count = DB::table('rate_cart')->where('exam_id',$exam_id)->where('book_id',$book_id)->where('min_qty',$min_qty)->where('max_qty',$max_qty)->count();
			if($rate_count == 1){
				$response = array('Remarks'=>'Already exist','status'=>0);
			}else{
				
				$rate_insert = DB::table('rate_cart')->insert(
				   ['exam_id'=>$exam_id,'book_id'=>$book_id,'price'=>$mrp,'min_qty'=>$min_qty,'max_qty'=>$max_qty,'bulk_price'=>$bulk_price,'discount'=>$discount,'discount_percentage'=>$discount_percentage,'ts'=>$ts]); 
				   
				   $response = array('Remarks'=>'Inserted Successfully','status'=>1,'exam_id'=>$exam_id,'book_id'=>$book_id,'price'=>$mrp,'min_qty'=>$min_qty,'max_qty'=>$max_qty,'bulk_price'=>$bulk_price,'discount'=>$discount,'discount_percentage'=>$discount_percentage);
			}

		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        } 
		    echo json_encode($response);
	}

	//Registration data
	
	public function RegisteredUserApi(){ 

		try{

			$reg_row = DB::table('buyer_register')->whereNotIn('email_id',['neerajit@ssccglpinnacle.com','kaim@ssccglpinnacle.com','haridutt@ssccglpinnacle.com','hari@hari.hari','baljitdhaka@ssccglpinnacle.com'])->get();

			$i=1;
			foreach($reg_row as $row){

				$name = $row->name;
				$email_id = $row->email_id;
				$mobile = $row->mobile;
				$state = $row->state;
				$ts = $row->ts;

				$response[] = array('id'=>$i,'name'=>$name,'email_id'=>$email_id,'mobile'=>$mobile,'state'=>$state,'ts'=>$ts);

				$i++;
			}

		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        }
		echo json_encode($response);
	}
	
	//orders
	
	public function OrderApi(Request $req){
		 $type = isset($req['type'])?$req['type']:'';
		try{
			if($type == 'SUCCESS'){
			$trans_row_count = DB::table('buyer_buy')->where('status','SUCCESS')->groupBy('transaction_id')->count();   
			if($trans_row_count > 0){
			$trans_id = 1;
			$trans_row = DB::table('buyer_buy')->where('status','SUCCESS')->groupBy('transaction_id')->orderBy('id','DESC')->get();
			}else{
			$trans_id = 0;
			}
			}else if($type == 'PENDING'){
			$trans_row_count = DB::table('buyer_buy')->where('status','PENDING')->groupBy('transaction_id')->count();
			if($trans_row_count > 0){
			$trans_id = 1;	
			$trans_row = DB::table('buyer_buy')->where('status','PENDING')->groupBy('transaction_id')->orderBy('id','DESC')->get();
			}else{
			$trans_id = 0;	
			}
			}else if($type == 'FAILED'){
			$trans_row_count = DB::table('buyer_buy')->where('status','FAILED')->groupBy('transaction_id')->count();
			if($trans_row_count > 0){
			$trans_id = 1;	
			$trans_row = DB::table('buyer_buy')->where('status','FAILED')->groupBy('transaction_id')->orderBy('id','DESC')->get();
			}else{
			$trans_id = 0;	
			}
			}

			if($trans_id == 0){ 
				$resp[] = array('id'=>1);
				$response[] = array('details'=>$resp,'status'=>0);	
			}else{

			foreach($trans_row as $t_row){

				$transaction_id = $t_row->transaction_id;

				$paid_amount_query = DB::table('books_paid_amount')->where('transaction_id',$transaction_id)->first();

			    $paid_amount = $paid_amount_query->paid_amount;
				
				$total_prices = DB::table('buyer_buy')->where('transaction_id',$transaction_id)->sum('pay_amount');

				$total_price = round($total_prices,2);

				$reg_row = DB::table('buyer_buy')->where('transaction_id',$transaction_id)->whereNotIn('email_id',['neerajit@ssccglpinnacle.com','kaim@ssccglpinnacle.com','haridutt@ssccglpinnacle.com','hari@hari.hari','baljitdhaka@ssccglpinnacle.com'])->get();

				$i=1;
				$resp = array();
				foreach($reg_row as $row){
				$email_id = $row->email_id;
				$book_id = $row->book_id;
				$payment_mode = $row->payment_mode;
				$pay_amount = $row->pay_amount;
				$ts = $row->ts;
     
				$book_row = DB::table('books_master_table')->where('id',$book_id)->first();
				$book_title = $book_row->book_title;

				$register_row = DB::table('buyer_register')->where('email_id',$email_id)->first();
				$name = $register_row->name;
				$mobile = $register_row->mobile;

				if($type == 'SUCCESS'){
				$cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->where('status',2)->first();
				$quantity = $cart_row->quantity;
				}else{
				$cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->first();
				$quantity = $cart_row->quantity;	
				}
				$resp[] = array('id'=>$i,'name'=>$name,'email_id'=>$email_id,'mobile'=>$mobile,'book_title'=>$book_title,'quantity'=>$quantity,'book_pay_amount'=>$pay_amount,'payment_mode'=>$payment_mode,'ts'=>$ts);

				$i++;
			   }
			   $response[] = array('transaction_id'=>$transaction_id,'total_price'=>$total_price,'paid_amount'=>$paid_amount,'discount'=>'5000','details'=>$resp,'status'=>1);
			  }
			}

		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        }
		    echo json_encode($response);
	}

	//Cancelled orders
	
	public function CancelledOrderApi(Request $req){
		$type = isset($req['type'])?$req['type']:'';
		try{
			$trans_row_count = DB::table('buyer_buy')->where('status','CANCELLED')->count();
			if($trans_row_count > 0){

			$trans_row = DB::table('buyer_buy')->where('status','CANCELLED')->whereNotIn('email_id',['neerajit@ssccglpinnacle.com','kaim@ssccglpinnacle.com','haridutt@ssccglpinnacle.com','hari@hari.hari','baljitdhaka@ssccglpinnacle.com'])->get();

			$i=1;
			foreach($trans_row as $row){

				$email_id = $row->email_id;
				$book_id = $row->book_id;
				$pay_amount = $row->pay_amount;
				$ts = $row->ts;

				$book_row = DB::table('books_master_table')->where('id',$book_id)->first();
				$book_title = $book_row->book_title;

				$register_row = DB::table('buyer_register')->where('email_id',$email_id)->first();
				$name = $register_row->name;
				$mobile = $register_row->mobile;

				$cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->where('status',0)->first();
				$quantity = $cart_row->quantity;

				$response[] = array('id'=>$i,'name'=>$name,'email_id'=>$email_id,'mobile'=>$mobile,'book_title'=>$book_title,'quantity'=>$quantity,'book_pay_amount'=>$pay_amount,'ts'=>$ts,'status'=>1);

				$i++;
			   }

			}else{
			  $response[] = array('status'=>0);
			}

		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        }
		    echo json_encode($response);
	}
	
	//Login

	public function AdminLogin(Request $req){
		$email_id = isset($req['email_id'])?$req['email_id']:'';
		$password = isset($req['password'])?$req['password']:'';
		
		try{ 
			if($email_id == 'ssccglpinnacle@gmail.com' && $password == '12345'){
				$response = array('status'=>1);
			}else{
				$response = array('status'=>0);
			}
		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        }
		echo json_encode($response);
	}
	
	//test
	
	public function Image(){ 
		
		try{
			
			$response = array('image'=>'https://ssccglpinnacle.com/admin/drag/uploads/SSC Reasoning Shift wise Hindi medium.png');
			  
		}catch(Exception $e){
	       return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
        }
		echo json_encode($response);
	}
	
	
}