<?php

namespace App\Http\Controllers;

use App\Models\RankingModel;

use App\Models\AnswerListModel;

use Illuminate\Http\Request;

use DB;

class AttemptedController extends Controller
{
    public function Attempted(Request $req){

        if($req->exam_mode_id == 1){
            $table = 'full_test_table';
        }else if($req->exam_mode_id == 2){
            $table = 'subject_test_table';
        }else if($req->exam_mode_id == 3){
            $table = 'chapter_test_table';
        }else{
            $table = 'previous_test_table';
        }

        $collection = RankingModel::where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->orderBy('total_marks','DESC')->get();
        $data       = $collection->where('email_id',$req->email_id);
        $rank       = $data->keys()->first() + 1;
        $total_std = $collection->count();
        $topper_query = $collection->first();
        $topper_email = $topper_query->email_id;

        $total_attempted_std = AnswerListModel::distinct()->count('email_id');
        
        $m_query = RankingModel::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->first();
        $obtain_marks = $m_query->total_marks;
        $total_time_taken = $m_query->total_time_taken;

        $marks_query = DB::table('paper_code_master_table')->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->first();
        $total_marks = $marks_query->marks;
        $total_ques = $marks_query->questions;
        $time = $marks_query->time;

        $you_total_attempted = AnswerListModel::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->whereIN('answer_status',[1,4])->count();

        $answer_query = AnswerListModel::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->whereIN('answer_status',[1,4])->get();
        $corr = array();
        $wrong = array();
        foreach($answer_query as $row){
            $ques_no = $row->question_no;
            $choose_answer = $row->answer;
            $correct_answer = $row->correct_answer;
            if($correct_answer == $choose_answer){
                $corr[] = $correct_answer;
            }else{
                $wrong[] = $choose_answer;
            }
        }
        $you_total_correct = count($corr);
        $you_total_wrong = count($wrong);
        if($you_total_attempted == 0){
            $accuracy = 0;
        }else{
            $accuracy = round((($you_total_correct*100)/$you_total_attempted),2);
        }
        $percentile = round(((($total_std - $rank)/$total_std)*100),2);

        $m_query = DB::table($table)->where('paper_code',$req->paper_code)->first();
        $postive_marks = $m_query->marks;
        $negative_marks = $m_query->minus_marking;

        $sub_query = DB::table('paper_code_master_table')->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->groupBy('subject_id')->get();
        $total_subject = $sub_query->count();
        $total_time = count($sub_query);
        foreach($sub_query as $sb){
            $subject_id = $sb->subject_id;
            $questions = $sb ->questions;
            $total_mrk = $sb ->marks;

            $sb_query = DB::table('subject_master_table')->where('id',$subject_id)->first();
            $subject_name = $sb_query->subject_name;

            $sbj_query = AnswerListModel::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->where('subject_id',$subject_id)->whereIN('answer_status',[1,4])->get();
            $sb_corr_ans = array();
            $n_marks = array();
            $atmp = array();
            foreach($sbj_query as $sb_ans_query) {
                $ch_ans = $sb_ans_query->answer;
                $corr_ans = $sb_ans_query->correct_answer;
                $atmp[] = $sb_ans_query->question_no;

                if($ch_ans == $corr_ans){
                    $sb_corr_ans[] = $ch_ans;
                }else{
                    $n_marks[] = $ch_ans;
                }
            }

            $pos_marks = count($sb_corr_ans) * $postive_marks;
            $neg_marks = count($n_marks) * $negative_marks;
            $t_sb_marks = $pos_marks - $neg_marks;
            $sb_total_marks = $total_mrk/$total_subject;
            $sb_attemted = count($atmp);
            $sb_total_ques = $questions/$total_subject;
            $sb_correct_ans = count($sb_corr_ans);
            if($sb_attemted != 0){
                $sb_accuracy = round((($sb_correct_ans/$sb_attemted)*100),2);
            }else{
                $sb_accuracy = 0;
            }
            $sb_total_time =  $time/$total_time;

            $sbj_time_query = AnswerListModel::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->where('subject_id',$subject_id)->get();
            $ans_time = array();
            foreach($sbj_time_query as $sbt_query) {
                $ans_time[] = $sbt_query->answer_time;
            }

            $total = 0;
            foreach( $ans_time as $element){
                $temp = explode(":", $element);
                $total+= (int) $temp[0] * 3600;
                $total+= (int) $temp[1] * 60;
                $total+= (int) $temp[2];
            }
            $sb_time = sprintf('%02d:%02d:%02d',($total / 3600),($total / 60 % 60),$total % 60);

            $score_percentage = round((($t_sb_marks/$sb_total_marks)*100),2);
            $attempted_percentage = round((($sb_attemted/$sb_total_ques)*100),2);
            $time_percentage = round((($total/($time*100))*100),2);

            $resp[] = array('subject_id'=>$subject_id,'SubjectName'=>$subject_name,'SubScore'=>$t_sb_marks,'SubTotalMarks'=>$sb_total_marks,'SubAttempted'=>$sb_attemted,'SubTotalQuestion'=>$sb_total_ques,'SubAccuracy'=>$sb_accuracy,'SubTakingTime'=>$sb_time,'SubTotalTime'=>$sb_total_time,'score_percentage'=>$score_percentage,'attempted_percentage'=>$attempted_percentage,'time_percentage'=>$time_percentage);
        }

        //topper

        $tp_answer_query = AnswerListModel::where('email_id',$topper_email)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->whereIN('answer_status',[1,4])->get();
        $tp_total_attempted = $tp_answer_query->count();
        $tp_corr = array();
        $wrong_ques = array();
        foreach($tp_answer_query as $tp_row){
            $tp_ques_no = $tp_row->question_no;
            $tp_choose_answer = $tp_row->answer;
            $tp_correct_answer = $tp_row->correct_answer;
            if($tp_correct_answer == $tp_choose_answer){
                $tp_corr[] = $tp_choose_answer;
            }else{
                $wrong_ques[] = $tp_choose_answer;
            }
        }
        $tp_total_correct = count($tp_corr);
        if($tp_total_attempted == 0){
            $tp_accuracy = 0;
        }else{
            $tp_accuracy = round((($tp_total_correct*100)/$tp_total_attempted),2);
        }

        $tp_wrong_question = count($wrong_ques);
    
        $tp_query = RankingModel::where('email_id',$topper_email)->where('paper_code',$req->paper_code)->first();

        $tp_obtain_marks = $tp_query->total_marks;
        $tp_total_time_taken = $tp_query->total_time_taken;
        //end topper

        //avg

        $avg_marks = round(RankingModel::where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->avg('total_marks'),2);

        $avg_answer_query = AnswerListModel::where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->whereIN('answer_status',[1,4])->get();
        $avg_total_attempted = $avg_answer_query->count();
        $avg_corr = array();
        $avg_wrong_ques = array();
        $avg_answer_time = array();
        foreach($avg_answer_query as $avg_row){
            $avg_ques_no = $avg_row->question_no;
            $avg_choose_answer = $avg_row->answer;
            $avg_correct_answer = $avg_row->correct_answer;
            $avg_answer_time[] = $avg_row->answer_time;
            if($avg_correct_answer == $avg_choose_answer){
                $avg_corr[] = $avg_choose_answer;
            }else{
                $avg_wrong_ques[] = $avg_choose_answer;
            }
        }
        $avg_total_correct = count($avg_corr);
        $avg_attempted_correct = round(($avg_total_correct/$total_attempted_std),2);
        if($avg_total_attempted == 0){
            $avg_accuracy = 0;
        }else{
            $avg_accuracy = round((($avg_total_correct*100)/$avg_total_attempted),2);
        }

        $avg_wrong_question = round((count($avg_wrong_ques)/$total_attempted_std),2);

        $av_total = 0;
        foreach( $avg_answer_time as $ele){
            $tmp = explode(":", $ele);
            $av_total+= (int) $tmp[0] * 3600;
            $av_total+= (int) $tmp[1] * 60;
            $av_total+= (int) $tmp[2];
        }
        $avt = $av_total/$total_attempted_std;
        $avg_time = sprintf('%02d:%02d:%02d',($avt / 3600),($avt / 60 % 60),$avt % 60);

        $your_score_perc = round((($obtain_marks/$total_marks)*100),2);
        $your_correct_perc = round((($you_total_correct/$total_ques)*100),2);
        $your_wrong_perc = round((($you_total_wrong/$total_ques)*100),2);
        $tmp_time = explode(":", $total_time_taken);
        $y_total=0;
        $y_total+= (int) $tmp_time[0] * 3600;
        $y_total+= (int) $tmp_time[1] * 60;
        $y_total+= (int) $tmp_time[2];
        $your_time_perc = round((($y_total/($time*60))*100),2);

        $topper_score_perc = round((($tp_obtain_marks/$total_marks)*100),2);
        $topper_correct_perc = round((($tp_total_correct/$total_ques)*100),2);
        $topper_wrong_perc = round((($tp_wrong_question/$total_ques)*100),2);
        $tp_tmp = explode(":", $tp_total_time_taken);
        $tp_total=0;
        $tp_total+= (int) $tp_tmp[0] * 3600;
        $tp_total+= (int) $tp_tmp[1] * 60;
        $tp_total+= (int) $tp_tmp[2];
        $topper_time_perc = round((($tp_total/($time*60))*100),2);

        $avg_time_perc = round((($avt/($time*60))*100),2);

        $compare[] = array('YourScore'=>$obtain_marks,'TotalScore'=>$total_marks,'YourAccuracy'=>$accuracy,'YourCorrect'=>$you_total_correct,'YourWrong'=>$you_total_wrong,'YourTime'=>$time,'TopperScore'=>$tp_obtain_marks,'TopperAccuracy'=>$tp_accuracy,'TopperCorrect'=>$tp_total_correct,'TopperWrong'=>$tp_wrong_question,'TopperTime'=>$tp_total_time_taken,'AvgScore'=>$avg_marks,'AvgAccuracy'=>$avg_accuracy,'AvgCorrect'=>$avg_attempted_correct,'AvgWrong'=>$avg_wrong_question,'AvgTime'=>$avg_time,'AvgTotalTimeTaken'=>$total_time_taken,'your_score_perc'=>$your_score_perc,'your_correct_perc'=>$your_correct_perc,'your_wrong_perc'=>$your_wrong_perc,'topper_score_perc'=>$topper_score_perc,'topper_correct_perc'=>$topper_correct_perc,'topper_wrong_perc'=>$topper_wrong_perc,'your_time_perc'=>$your_time_perc,'topper_time_perc'=>$topper_time_perc,'avg_time_perc'=>$avg_time_perc);
        //end avg

        //top 10 ranker
 
        $top_rnk = $collection->take(10);
        foreach($top_rnk as $t_rnk){ 
            $tr_email = $t_rnk->email_id;
            $tr_marks = $t_rnk->total_marks;

            $name_query = DB::table('student_register')->where('email_id',$tr_email)->first();
            if($name_query !== null){
               $full_name = $name_query->full_name;
            }else{
                $full_name = '';
            }

            $top_ranker[] = array('Name'=>$full_name,'RankerMarks'=>$tr_marks);
        }
        //end ranker

        //graph 
        $graph_average_marks = $total_marks/10;  

        for($i=0;$i<$total_marks;$i += $graph_average_marks){

            $k = $i + $graph_average_marks;	

            $graph_sql = $collection->whereBetween('total_marks', [$i, $k]);

            $graph_student_count = $graph_sql->count();

            $ar[] = $i."-".$k;

            $gdata[] = $graph_student_count;
        }

        $graph[] = array('label'=>$ar,'data'=>$gdata); 

        //end graph start cutoff

        $cutoff_data = DB::table('category_cutoff_table')->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->first();
        if ($cutoff_data === null) {
            $ur = '';
            $ews = '';
            $obc = '';
            $sc = '';
            $st = '';
            $oh = '';
            $hh = '';
            $vh = '';
            $Others_PWD = '';
            $esm = '';
            $cutoff_status = 0;
        }else{
            $ur = $cutoff_data->ur;
            $ews = $cutoff_data->ews;
            $obc = $cutoff_data->obc;
            $sc = $cutoff_data->sc;
            $st = $cutoff_data->st;
            $oh = $cutoff_data->oh;
            $hh = $cutoff_data->hh;
            $vh = $cutoff_data->vh;
            $Others_PWD = $cutoff_data->Others_PWD;
            $esm = $cutoff_data->esm;
            $cutoff_status = 1;           
        }

        //end cutoff

        $y_total_attempted = round((($you_total_attempted/$total_ques)*100),2);
        $match[] = array('Rank'=>$rank,'TotalStudent'=>$total_std,'Score'=>$obtain_marks,'TotalMarks'=>$total_marks,'Attempted'=>$you_total_attempted,'TotalQuestions'=>$total_ques,'Accuracy'=>$accuracy,'Percentile'=>$percentile,'Totaltime'=>$time,'TotalTimeTaken'=>$total_time_taken,'Subjects'=>$resp,'compare'=>$compare,'TopRanker'=>$top_ranker,'graph'=>$graph,'your_score_perc'=>$your_score_perc,'y_total_attempted'=>$y_total_attempted,'your_time_perc'=>$your_time_perc,'ur'=>$ur,'ews'=>$ews,'obc'=>$obc,'sc'=>$sc,'st'=>$st,'oh'=>$oh,'hh'=>$hh,'vh'=>$vh,'Others_PWD'=>$Others_PWD,'esm'=>$esm,'cutoff_status'=>$cutoff_status);

        echo json_encode($match);
    }
       
    //attempted api
    public function AttemptedTestApi(Request $req){   
        $email_id = isset($req[0]['email_id'])?$req[0]['email_id']:'';

        $test_series_data = DB::table('paper_status_table')->where('status',1)->where('email_id',$email_id)->get();

        if(count($test_series_data) > 0){

            foreach($test_series_data as $row){
                $paper_code = $row->paper_code;
                $test_series_id = $row->test_series_id;
                $exam_mode_id = $row->exam_mode_id;
                $old_date = $row->ts;
                $attempted_date = date("D, d M Y", strtotime($old_date));

                $collection = RankingModel::where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->orderBy('total_marks','DESC')->get();
                $data       = $collection->where('email_id',$email_id);
                $rank       = $data->keys()->first() + 1;
                $total_std = $collection->count();

                $m_query = RankingModel::where('email_id',$email_id)->where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->first();
                $obtain_marks = $m_query->total_marks;

                $marks_query = DB::table('paper_code_master_table')->where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->first();
                $paper_marks = $marks_query->marks;
                $test_title = $marks_query->test_title;
                $end_date = $marks_query->end_date;
                $end_time = $marks_query->end_time;
                $subject_id = $marks_query->subject_id;

                $attempted_ar[] = array('paper_code'=>$paper_code,'test_title'=>$test_title,'attempted_date'=>$attempted_date,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id,'expiry_date'=>$end_date,'expiry_time'=>$end_time,'subject_id'=>$subject_id,'Rank'=>$rank,'TotalStudent'=>$total_std,'Score'=>$obtain_marks,'TotalMarks'=>$paper_marks);
            }
        }else{
            $attempted_ar = array();
        }

        echo json_encode($attempted_ar);

    }


    public function UpdateAnswer(Request $req){   
        $data = AnswerListModel::where('exam_mode_id',4)->where('correct_answer','=','')->take(1000)->get();
        print_r($data);
        foreach($data as $dt){
            $paper_code = $dt->paper_code;
            $question_no = $dt->question_no;  

            $test_table = DB::table('previous_test_table')->where('paper_code',$paper_code)->where('paper_id',$question_no)->first();
            if($test_table != null){
                $correct_answer = $test_table->correct_answer;
            
                $data = AnswerListModel::where('exam_mode_id',4)->where('paper_code',$paper_code)->where('question_no',$question_no)->update(['correct_answer'=>"$correct_answer"]);
            }
        } 
    }
}
 