<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use DB;

class BillingController extends Controller
{
    public function BillingAddress(Request $req){
		$name = isset($req['name'])?$req['name']:'';
	    $mobile = isset($req['mobile'])?$req['mobile']:'';
		$pincode = isset($req['pincode'])?$req['pincode']:'';
	    $house = isset($req['house'])?$req['house']:'';
		$area = isset($req['area'])?$req['area']:'';
		$landmark = isset($req['landmark'])?$req['landmark']:'';
		$city = isset($req['city'])?$req['city']:'';
		$region = isset($req['region'])?$req['region']:'';
		$email_id = isset($req['email_id'])?$req['email_id']:'';
		
		try{
			date_default_timezone_set('asia/kolkata');
	        $ts = date('y-m-d h:i:s');
			//$address = $house.' '.$area.' '.$landmark.' '.$city.' '.$region;
			
			$usercount = DB::table('buyer_register')->where('email_id',$email_id)->count();

			if($usercount == 1){

				$res = DB::table('buyer_register')->where('email_id',$email_id)->update(
				   ['name'=>$name,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'ts'=>$ts]
				);
				$response[] = array('email_id' =>$email_id,'firstname'=>$name,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'status'=>'1');

			}else{

				$res = DB::table('buyer_register')->insert(
				   ['name'=>$name,'email_id'=>$email_id,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'ts'=>$ts]
				);

				$response[] = array('email_id' =>$email_id,'firstname'=>$name,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'status'=>'0');

			}

		}catch(Exception $e){
			return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
		}
		echo json_encode($response);
	}

	//review order

	public function ReviewOredrApi(Request $req){
		$email_id = isset($req['email_id'])?$req['email_id']:'';

		try{

		   $user = DB::table('buyer_register')->where('email_id',$email_id)->first();
		   $name = $user->name;
		   $mobile = $user->mobile;
		   $house = $user->home;
		   $landmark = $user->landmark;
		   $area = $user->area;
		   $city = $user->city;
		   $region = $user->state;
		   $pincode = $user->pincode;

		   $cart_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->count();
		   if($cart_count >= 1){
			   $total_price_count = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('total_price');   
			   $total_bulk_price_counts = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('total_bulk_price');
			   $total_bulk_price_count = round($total_bulk_price_counts,2);
			   $total_quantity = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('quantity');   
			   $total_discounts = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->sum('discount');
			   $total_discount = round($total_discounts,2);
			   $total_discount_per = round((($total_discount*100)/$total_price_count),2);

			   $cart_row = DB::table('add_to_cart')->where('email_id',$email_id)->where('status',0)->get();
			   $ar = array();
			   foreach($cart_row as $row){
				   $book_id = $row->book_id;
				   $book_price = $row->price;
				   $total_price = $row->total_price;
				   $quantity = $row->quantity;  
				   $bulk_price = $row->bulk_price;
				   $total_bulk_price = $row->total_bulk_price;
				   $discount = $row->discount;
				   $discount_percentage = $row->discount_percentage;

				   $book_data = DB::table('books_master_table')->where('id',$book_id)->first();
		           $book_title = $book_data->book_title;
		           $book_image_path = $book_data->book_image_path;
				   $min_qty = DB::table('rate_cart')->where('book_id',$book_id)->first();
				   $minimum_qty = $min_qty->min_qty;   

				   $ar[] = array('book_id'=>$book_id,'book_title'=>$book_title,'book_image_path'=>$book_image_path,'book_price'=>$book_price,'quantity'=>$quantity,'total_price'=>$total_price,'bulk_price'=>$bulk_price,'total_bulk_price'=>$total_bulk_price,'discount'=>$discount,'minimum_qty'=>$minimum_qty,'discount_percentage'=>$discount_percentage);
			   }
			   
			   $buyer_row_count = DB::table('buyer_buy')->where('email_id',$email_id)->where('status','SUCCESS')->count();
			   
			   if($buyer_row_count < 1){
				   if($total_quantity >= 300){
				   $total_bulk_price_count = $total_bulk_price_count - 5000;
				   $first_discount = 1;
				   }else{
				   $total_bulk_price_count = $total_bulk_price_count;
				   $first_discount = 0;   
				   }
			   }else{
				   $total_bulk_price_count = $total_bulk_price_count;
				   $first_discount = 0;
			   }  

			   $response[] = array('name'=>$name,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'cart_count'=>$total_quantity,'total_item'=>$cart_count,'overall_price'=>$total_price_count,'overall_bulk_price'=>$total_bulk_price_count,'total_discount'=>$total_discount,'total_discount_percentage'=>$total_discount_per,'book_details'=>$ar,'first_discount'=>$first_discount);
  
		   }else{
			   $response[] = array('Remarks'=>'No Data','status'=>0);
		   }
		}catch(Exception $e){
			return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
		}
		echo json_encode($response);
	}
	
	//edit billing address
	public function EditBillingAddress(Request $req){
		$email_id = isset($req['email_id'])?$req['email_id']:'';
		
		try{
			$usercount = DB::table('buyer_register')->where('email_id',$email_id)->count();
			if($usercount == 1){
				$row = DB::table('buyer_register')->where('email_id',$email_id)->first();
				$name = $row->name;
				$mobile = $row->mobile;
				$pincode = $row->pincode;
				$house = $row->home;
				$landmark = $row->landmark;
				$area = $row->area;
				$city = $row->city;
				$region = $row->state;
				
				$response[] = array('firstname'=>$name,'mobile'=>$mobile,'home'=>$house,'area'=>$area,'landmark'=>$landmark,'city'=>$city,'state'=>$region,'pincode'=>$pincode,'status'=>'0');
			}else{
				$response[] = array('Remark'=>'User does not exist','status'=>0);
			}
		}catch(Exception $e){
			return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
		}
		echo json_encode($response);
	}
}
