<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use Validator;
use AppOrder;     
use DateTime;                                    
use App\Models\Order;    
use DB;             
use PDF;    
use Storage;                          
      
class CashfreeController extends Controller
{           

    public function __construct() {     
        $this->APP_ID = "179295265b341b9c3d969d6895592971";
        $this->SECRET_KEY = "ec1462b1722c97a6bc8d89325d844e3d03ed2ce8";   

        $this->minimumAmount = 1;             
        $this->maximumAmount = 1000000;                                          
    }          
         
    function cashfree_payment_gateway (){   
        return View('cashfree_payment_gateway');                                
    }

    function order (Request $request){
        $this->validate($request, [
            'customerName' => 'required',
            'customerPhone' => 'required',
            'customerEmail' => 'required|email',
            'amount' => 'required|numeric|between:'.$this->minimumAmount.','.$this->maximumAmount.'',
        ]);                 
           
        $customerName = $request->customerName;   
        $customerPhone = $request->customerPhone;
        $customerEmail = $request->customerEmail;
        $amount = $request->amount;
        $now = new DateTime();
        $ctime = $now->format('Y-m-d H:i:s');   
             
        /* $orderId = Order::insertGetId([
            'customerName' => $customerName,
            'customerPhone' => $customerPhone,   
            'customerEmail' => $customerEmail,
            'amount' => $amount,   
            'created_at' => $ctime,
            'status_id' => 3,
        ]); */
		    
		//$orderId = $customerEmail;
		//$orderId = $customerEmail;    
		
		$digits = 4;         
	    $order_no = rand(pow(10, $digits-1), pow(10, $digits)-1);
		$orderids = $customerPhone.'-'.$order_no;
		
        $secretKey =  $this->SECRET_KEY;   
        $postData = array(
            "appId" => $this->APP_ID,
            "orderId" => $orderids,
            "orderAmount" => $amount,      
            "orderCurrency" => 'INR', 
            "orderNote" => 'Wallet',   
            "customerName" => $customerName,
            "customerPhone" => $customerPhone,
            "customerEmail" => $customerEmail,                     
            "returnUrl" => url('return-url'),
            "notifyUrl" => url('notify-url'),   
            'secretKey' => $secretKey,
        ); 
	
		return view('cashfree_confirmation')->with($postData);   
		                        
    } 

    public function DownloadPDF($postData){   
	   $transaction_id = $postData;                          
	  /* $book_id = 14;        
	  $pay_amount = 45878;*/        
	  //$articles = ['Article 1','Article 2','Article 3'];             
      $book_details = DB::table('buyer_buy')->where('transaction_id',$transaction_id)->where('status','SUCCESS')->get();         
      $sum_payment = DB::table('buyer_buy')->where('transaction_id',$transaction_id)->where('status','SUCCESS')->sum('pay_amount');    
      $grandtotal = round($sum_payment, 2);                                            
	  $date = date("d/m/Y");
	               
	  foreach($book_details as $book_detail) {        
			$email_id = $book_detail->email_id;                                 
			$book_id = $book_detail->book_id;        
			$pay_amount = $book_detail->pay_amount;                         
          
			$cart_details = DB::table('add_to_cart')->where('email_id',$email_id)->where('book_id',$book_id)->orderBy('book_id','desc')->first();  
            $bulk_price = $cart_details->bulk_price;			
            $quantity = $cart_details->quantity;			
			   
			$book_names = DB::table('books_master_table')->where('id',$book_id)->first(); 
            $book_title = $book_names->book_title;			
	                       
			$books[] = ['book_title'=>$book_title,'bulk_price'=>$bulk_price,'pay_amount'=>$pay_amount,'quantity'=>$quantity];          
	  }	     
                        
      $book_details_email = DB::table('buyer_buy')->where('transaction_id',$transaction_id)->where('status','SUCCESS')->first(); 
      $email = $book_details_email->email_id;	 
	  
	  $discount_details_email = DB::table('books_paid_amount')->where('transaction_id',$transaction_id)->count(); 
      if($discount_details_email == 1){
	  $grandtotal -= 5000;                             
	  }         
			   
      $distributor_name = DB::table('buyer_register')->where('email_id',$email)->first(); 	  
	  $distributors_name = $distributor_name->name;
	  $state = $distributor_name->state;   
	  $pincode = $distributor_name->pincode;   
	  $address = $state.' - '.$pincode;      
	      
	 // print_r($articles);      
	  //$book_name = 'ssc math Hindi';              
	  //$articles = array('book'=>$book_name,'qty'=>100,'rate'=>232,'amount'=>23200);;    
	  //$state = "BIHAR";                                          
	  //$distributors_name = "SUNIL BOOK DISTRIBUTORS";          
      $pdf = PDF::loadView("invoice", compact('address','distributors_name','books','grandtotal','date'));
      Storage::put('/opt/bitnami/apache/htdocs/laravel/public/pdf/'.$distributors_name.'.pdf', $pdf->output());	 	  
      //$pdf->download($distributors_name.'.pdf');                                 
                                          
      return redirect('https://www.pinnaclebooksdistributors.com/'); 	     
                                                    
    }   
         
    function return_url (Request $request){
        //print_r($request->all());die;                 
        //$customerEmail = $request->customerEmail;
        $orderId = $request->orderId;
        $orderAmount = $request->orderAmount;        
        $referenceId = $request->referenceId;      
        $txStatus = $request->txStatus;
        $paymentMode = $request->paymentMode;
        $txMsg = $request->txMsg;    
        $txTime = $request->txTime;    
        $signature = $request->signature;        
        $secretkey = $this->SECRET_KEY;

		$order_explode = explode('-',$orderId);
		$mobile_num = $order_explode[0];
		
		$customerEmai = DB::table('buyer_register')->where('mobile', $mobile_num)->first();
		$emailId = $customerEmai->email_id;
		   
        $data = $orderId . $orderAmount . $referenceId . $txStatus . $paymentMode . $txMsg . $txTime;
        $hash_hmac = hash_hmac('sha256', $data, $secretkey, true);
        $computedSignature = base64_encode($hash_hmac);	
        if ($signature == $computedSignature) {         
            if ($txStatus == 'SUCCESS'){                      
                // success query  
                $book_rows = DB::table('add_to_cart')->where('email_id',$emailId)->where('status','0')->get();
				foreach($book_rows as $book_row){
					
				$book_id = $book_row->book_id;
				$bulk_price = $book_row->total_bulk_price;

                $ins_query = DB::table('buyer_buy')->insert(['email_id'=>$emailId,'book_id'=>$book_id,'transaction_id'=>$referenceId,'payment_mode'=>$paymentMode,'payment_type'=>'buyer','pay_amount'=>$bulk_price,'status'=>$txStatus,'ts'=>$txTime]);
				
				$cart_update = DB::table('add_to_cart')->where('email_id',$emailId)->where('book_id',$book_id)->where('status',0)->update(['status'=>2]);
				
				
				$cart_details = DB::table('add_to_cart')->where('email_id',$emailId)->where('book_id',$book_id)->orderBy('id','desc')->first();  
                $quantit[] = $cart_details->quantity;	
				$totalQuantity = array_sum($quantit);                             
                }
				
				$amount_rows_count = DB::table('buyer_buy')->where('email_id',$emailId)->where('status','SUCCESS')->count();
				
				if($totalQuantity >= 300){
				if($amount_rows_count < 1){
				$total_amount = $orderAmount + 5000; 
				}else{
				$total_amount = $orderAmount;          	                                        
				}     
				}else{
				$total_amount = $orderAmount;		
				}
				    
				$total_paid_query = DB::table('books_paid_amount')->insert(['email_id'=>$emailId,'transaction_id'=>$referenceId,'total_amount'=>$total_amount,'discount'=>'5000','paid_amount'=>$orderAmount,'ts'=>$txTime]);
     
                $postData = $referenceId;                                                         
				return $this->DownloadPDF($postData);    

				//return redirect('https://www.pinnaclebooksdistributors.com/'); 
            }else{
                // rejected query          
				$book_rows = DB::table('add_to_cart')->where('email_id',$emailId)->where('status','0')->get();
				foreach($book_rows as $book_row){
					
				$book_id = $book_row->book_id; 
				$bulk_price = $book_row->total_bulk_price;        
				
				$ins_query = DB::table('buyer_buy')->insert(['email_id'=>$emailId,'book_id'=>$book_id,'transaction_id'=>$referenceId,'payment_mode'=>$paymentMode,'payment_type'=>'buyer','pay_amount'=>$bulk_price,'status'=>$txStatus,'ts'=>$txTime]);
                }
				
				$amount_rows_count = DB::table('buyer_buy')->where('email_id',$emailId)->where('status','SUCCESS')->count();
				
				if($amount_rows_count < 1){
				$total_amount = $orderAmount + 5000; 
				}else{
				$total_amount = $orderAmount;	
				}
				$total_paid_query = DB::table('books_paid_amount')->insert(['email_id'=>$emailId,'transaction_id'=>$referenceId,'total_amount'=>$total_amount,'discount'=>'5000','paid_amount'=>$orderAmount,'ts'=>$txTime]);
				                                                                            
				return redirect('https://www.pinnaclebooksdistributors.com/'); 
            }                                    
		}else{    
               
            $book_rows = DB::table('add_to_cart')->where('email_id',$emailId)->where('status','0')->get();
			foreach($book_rows as $book_row){	
			
            $ins_query = DB::table('buyer_buy')->insert(['email_id'=>$emailId,'book_id'=>$book_id,'transaction_id'=>$referenceId,'payment_mode'=>$paymentMode,'payment_type'=>'buyer','pay_amount'=>$orderAmount,'status'=>$txStatus,'ts'=>$txTime]);

            } 
 
            return redirect('https://www.pinnaclebooksdistributors.com/');     
        }  
    }
}