<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\PaperCodeDetails;

use App\Models\PaperStatusTable;

use App\Models\AnswerListModel;

use DB;

class PaperCodeDetailsController extends Controller
{
    function PaperCodeDetailsApi(Request $req)
    {
       $paper_details = PaperCodeDetails::where('paper_code', $req->paper_code)->first();
       $paper_code = $paper_details->paper_code;
       $subject_id = $paper_details->subject_id;
       $questions = $paper_details->questions;
       $time = $paper_details->time;
       $title = $paper_details->test_title;
       $test_type = $paper_details->test_type;
       
       $user = PaperStatusTable::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->first();
       if ($user !== null) {
          $timesp = $user->remaining_time;
          $timesplit=explode(':',$timesp);
          $ss=($timesplit[0]*3600)+($timesplit[1])*60+($timesplit[2]);
       }else{
          $ss = $time*60;
       }

       $subject_data = DB::table('subject_master_table')->where('id',$subject_id)->first();
       $subject_name = $subject_data->subject_name;

       $s = $ss%60;
       $m = floor(($ss%3600)/60);
       $h = floor(($ss%86400)/3600);

       $answered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$req->email_id)->whereIN('answer_status',[1,4])->count();

       $notanswered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$req->email_id)->whereIN('answer_status',[2,3])->count();

       $marked_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$req->email_id)->where('answer_status',3)->count();

       $marked_answered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$req->email_id)->where('answer_status',4)->count();

       $total_answered =AnswerListModel::where('paper_code',$paper_code)->where('email_id',$req->email_id)->count();

       $not_visited = $questions - $total_answered;

       $resp = array('paper_code'=>$paper_code,'title'=>$title,'subject_id'=>$subject_id,'questions'=>$questions,'hrs'=>$h,'mins'=>$m,'secs'=>$s,'subject_name'=>$subject_name,'answered_count'=>$answered_count,'notanswered_count'=>$notanswered_count,'marked_count'=>$marked_count,'marked_answered_count'=>$marked_answered_count,'not_visited'=>$not_visited,'test_type'=>$test_type);

       return response($resp, 201);
    }

    /* public function CutoffApi(Request $req){
          $paper_code = isset($req['paper_code'])?$req['paper_code']:'';
          $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
          $cutoff = isset($req['cutoff'])?$req['cutoff']:'';

          $data = DB::table('category_cutoff_table')->where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->where()->first();
          $ur = $data->ur;
          $ews = $data->ews;
          $obc = $data->obc;
          $sc = $data->sc;
          $st = $data->st;
          $oh = $data->oh;
          $hh = $data->hh;
          $vh = $data->vh;
          $Others_PWD = $data->Others_PWD;
          $esm = $data->esm;

          $match = array('')
    } */
}
