<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\AnswerListModel;

use App\Models\PaperStatusTable;

use App\Models\PaperCodeDetails;

use App\Models\Bookmark;

use DB;

class SolutionController extends Controller
{
    public function Solution(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';

        if($exam_mode_id == 1){
            $table = 'full_test_table';
        }elseif($exam_mode_id == 2){
            $table = 'subject_test_table';
        }elseif($exam_mode_id == 3){
            $table = 'chapter_test_table';
        }elseif($exam_mode_id == 4){        
            $table = 'previous_test_table';
        }

        $sb_data = DB::table($table)->where('paper_code',$paper_code)->groupBy('subject_id')->orderBy('paper_id','ASC')->get();
        $ar = array();
        foreach($sb_data as $sb){
            $subj_id = $sb->subject_id;
            $ppr_id = $sb->paper_id;

            $subject_data = DB::table('subject_master_table')->where('id',$subj_id)->first();
            $subject_name = $subject_data->subject_name;

            $ar[] = array('sb_id'=>$subj_id,'ppr_id'=>$ppr_id,'subject_name'=>$subject_name);
        }

        $correct_count_query = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->whereIN('answer_status',[1,4])->get();
        $crans = array();
        $wrns = array();
        foreach($correct_count_query as $crow){
            $c_answer = $crow->answer;
            $c_correct_answer = $crow->correct_answer;

            if($c_correct_answer == $c_answer){
                $crans[] = $c_answer;
            }else{
                $wrns[] = $c_answer;
            }
        }

        $correct_count = count($crans);
        $incorrect_count = count($wrns);
        $total_ques = DB::table($table)->where('paper_code',$paper_code)->count();
        $unattempted_ques = $total_ques - ($correct_count + $incorrect_count);

        $data = DB::table($table)->where('paper_code',$paper_code)->get();
        foreach($data as $query){
        $paper_id = $query->paper_id;
        $question_id = $query->question_id;
        $correct_answer = $query->correct_answer;
        $subject_id = $query->subject_id;
        $positive_marks = $query->marks;
        $negative_marks = $query->minus_marking;
        $hindi_question = $query->hindi_question;
        $hindi_option1 = $query->option1_hindi;
        $hindi_option2 = $query->option2_hindi;
        $hindi_option3 = $query->option3_hindi;
        $hindi_option4 = $query->option4_hindi;
        $eng_question = $query->eng_question;
        $option1 = $query->option1;
        $option2 = $query->option2;
        $option3 = $query->option3;
        $option4 = $query->option4;
        $solution = $query->solution;
        $hindi_solution = $query->hindi_solution;
        if($hindi_solution == ''){
            $hindi_solution = $query->solution;
        }

        $answer_data = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('question_no',$paper_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->first();

        if($answer_data == null){
            $answered_ques = 0;
            $hrs = '00';
            $mins = '00';
            $secs = '00';
            $answer_type = 'Skipped';
            $choose_answer = '';
            $total_your_seconds = '00:00:00';
        }else{
            $ans_status = $answer_data->answer_status;
            $choose_answer = $answer_data->answer;
            $answer_status = $answer_data->answer_status;
            $answer_time = $answer_data->answer_time;
            $timesplit=explode(':',$answer_time);
            $hrs = $timesplit[0];
            $mins = $timesplit[1];
            $secs = $timesplit[2];

            $total_your_seconds = $hrs*3600+$mins*60+$secs;

            $answer_tm = AnswerListModel::where('paper_code',$paper_code)->where('question_no',$paper_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->get();
            $anstm = array();
            $qsid = array();
            $avgans = array();
            foreach($answer_tm as $tm){
                $anstm[] = $tm->answer_time;
                $qsid[] = $tm->question_no;
                $avg_choose_answer = $tm->answer;
                $avg_correct_answer = $tm->correct_answer;
                if($avg_choose_answer == $avg_correct_answer){
                    $avgans[] = $avg_choose_answer;
                }
            }
            $total_correct = count($avgans); 
            $total_student = count($qsid);
            $correcltly_per = round((($total_correct/$total_student)*100),2);
          
            $total = 0;
            foreach( $anstm as $element){
                $temp = explode(":", $element);
                $total+= (int) isset($temp[0]) * 3600;
                $total+= (int) isset($temp[1]) * 60;                       
                $total+= (int) isset($temp[2]);                                         
            }
            $total_seconds = $total/$total_student;
            $avg_time = sprintf('%02d:%02d:%02d',($total_seconds / 3600),($total_seconds / 60 % 60),$total_seconds % 60);

            if($answer_status == 1 || $answer_status == 4){
                if($choose_answer == $correct_answer){
                    $answer_type = 'Correct';
                    $answered_ques = 1;
                }else{
                    $answer_type = 'Incorrect';
                    $answered_ques = 2;
                }
            }else{
                $answer_type = 'Skipped';
                $choose_answer = '';
                $answered_ques = 0;
            }
        }
        $total_data = DB::table($table)->where('paper_code',$paper_code)->count();
        if($paper_id != $total_data){
          $s_data = $data->where('paper_id',$paper_id+1)->first();
          $sub_id = $s_data->subject_id;
        }
        if($paper_id != 1){
            $s_prv_data = $data->where('paper_id',$paper_id-1)->first();
            $sub_prv_id = $s_prv_data->subject_id;
        }else{
            $sub_prv_id = 1;
        }

        $bk = Bookmark::where('email_id', $email_id)->where('paper_code', $paper_code)->where('exam_mode_id', $exam_mode_id)->where('test_series_id', $test_series_id)->where('ques_no',$paper_id)->first();
        if ($bk !== null) {
            $bookmark_ques = 'Savednvg';
        }else{
            $bookmark_ques = 'unsave';
        }

        if($total_your_seconds < $total_seconds && $answer_type == 'Correct'){
            $time_status = 'You are Superfast';
        }else if($total_your_seconds > $total_seconds){
            $time_status = 'You were Slow';
        }else if($total_your_seconds == $total_seconds && $answer_type == 'Correct'){
            $time_status = 'You were on Time';
        }else if($total_your_seconds == $total_seconds && $answer_type == 'Incorrect'){
            $time_status = 'You were on Time but not Correct';
        }else if($total_your_seconds < $total_seconds && $answer_type == 'Incorrect'){
            $time_status = 'You were Slow';
        }else if($total_your_seconds == '00:00:00'){
            $time_status = 'skipped';
        }else if($total_your_seconds > $total_seconds && $answer_type == 'Skipped'){
            $time_status = 'You were Slow';
        }else if($total_your_seconds < $total_seconds && $answer_type == 'Skipped'){
            $time_status = 'You were on Time but not Correct';
        }else{
            $time_status = 'You were on Time but not Correct';
        }

        $response[] = array('qid'=>$paper_id,'question_id'=>$question_id,'sub_id'=>$sub_id,'sub_prv_id'=>$sub_prv_id,'subject_id'=>$subject_id,'question'=>$eng_question,'option1'=>$option1,'option2'=>$option2,'option3'=>$option3,'option4'=>$option4,'hindi_question'=>$hindi_question,'hindi_option1'=>$hindi_option1,'hindi_option2'=>$hindi_option2,'hindi_option3'=>$hindi_option3,'hindi_option4'=>$hindi_option4,'positive_marks'=>$positive_marks,'negative_marks'=>$negative_marks,'answered_ques'=>$answered_ques,'hrs'=>$hrs,'mins'=>$mins,'secs'=>$secs,'solution'=>$solution,'hindi_solution'=>$hindi_solution,'answer_type'=>$answer_type,'choose_answer'=>$choose_answer,'correct_answer'=>$correct_answer,'correct_count'=>$correct_count,'incorrect_count'=>$incorrect_count,'unattempted_ques'=>$unattempted_ques,'avg_time'=>$avg_time,'correcltly_per'=>$correcltly_per,'bookmark_ques'=>$bookmark_ques,'time_status'=>$time_status);
        }

        $resp[] = array('subjects'=>$ar,'details'=>$response);
   
        echo json_encode($resp);
    }

    public function BookmarkApi(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $savedquestion = isset($req['savedquestion'])?$req['savedquestion']:'';
        $type = isset($req['type'])?$req['type']:'';

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');

        if($type == 'Save'){
            $data = Bookmark::updateOrCreate(
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id,'ques_no'=>$savedquestion],
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id,'ques_no'=>$savedquestion,'ts'=>$ts]
            );
        }else{
            $user = Bookmark::where('ques_no', $savedquestion)->where('email_id', $email_id)->where('paper_code', $paper_code)->where('exam_mode_id', $exam_mode_id)->where('test_series_id', $test_series_id)->delete();
        }
    }

    public function NextApi(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $paperid = isset($req['paperid'])?$req['paperid']:'';
        
        $bk = Bookmark::where('email_id', $email_id)->where('paper_code', $paper_code)->where('exam_mode_id', $exam_mode_id)->where('test_series_id', $test_series_id)->where('ques_no',$paperid+1)->first();
        if ($bk !== null) {
            $bookmark_ques = 'Saved';
        }else{
            $bookmark_ques = 'Save';
        }
        $match = array('bookmark_ques'=>$bookmark_ques);
        echo json_encode($match);
    }

    public function RatingApi(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $rating = isset($req['rating'])?$req['rating']:'';
       
        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');

        $data_check = DB::table('performance_rating')->where('email_id', $email_id)->where('paper_code', $paper_code)->where('exam_mode_id', $exam_mode_id)->where('test_series_id', $test_series_id)->count();

        if($data_check == 0){
            $data = DB::table('performance_rating')->insert(
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id,'rating'=>$rating,'ts'=>$ts]
            ); 
        }else{
            $data = DB::table('performance_rating')->where('email_id', $email_id)->where('paper_code', $paper_code)->where('exam_mode_id', $exam_mode_id)->where('test_series_id', $test_series_id)->update(
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id,'rating'=>$rating,'ts'=>$ts]); 
        }
        
    }
}
