<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\RankingModel;

use App\Models\PaperStatusTable;

use App\Models\AnswerListModel;

use App\Models\PaperCodeDetails;

use DB;

class SubmitTestController extends Controller
{
    public function SubmitTest(Request $req){

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');

        if($req->exam_mode_id == 1){
            $table = 'full_test_table';
        }else if($req->exam_mode_id == 2){
            $table = 'subject_test_table';
        }else if($req->exam_mode_id == 3){
            $table = 'chapter_test_table';
        }else{
            $table = 'previous_test_table';
        }

        $data = PaperStatusTable::updateOrCreate(
            ['email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id],
            ['email_id'=>$req->email_id,'exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id,'paper_code'=>$req->paper_code,'status'=>1,'remaining_time'=>$req->rTem,'ts'=>$ts]
        );

        $m_query = DB::table($table)->where('paper_code',$req->paper_code)->first();
        $postive_marks = $m_query->marks;
        $negative_marks = $m_query->minus_marking;

        $ans_query = AnswerListModel::where('email_id', $req->email_id)->where('paper_code', $req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id', $req->test_series_id)->whereIN('answer_status',[1,4])->get();
        $pos_marks = array();
        $neg_marks = array();
        foreach($ans_query as $row){
            $choose_answer = $row->answer;
            $correct_answer = $row->correct_answer;
            if($choose_answer == $correct_answer){
                $pos_marks[] = $row->question_no;
            }else{
                $neg_marks[] = $row->question_no;
            }
        }
        $p_marks = count($pos_marks) * $postive_marks;
        $n_marks = count($neg_marks) * $negative_marks;
        $obtain_marks = $p_marks - $n_marks;

        $p_query = PaperCodeDetails::where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->first();
        $time = $p_query->time * 60;
        
        $tmp = explode(":", $req->rTem);
        $hrs = (int) $tmp[0] * 3600;
        $min = (int) $tmp[1] * 60;
        $sec = (int) $tmp[2];

        $total_sec = $time - ($hrs + $min + $sec);

        $taking_time = sprintf('%02d:%02d:%02d',($total_sec / 3600),($total_sec / 60 % 60),$total_sec % 60);

        $ranking = RankingModel::updateOrCreate(
            ['email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id],
            ['exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id,'email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'total_marks'=>$obtain_marks,'total_time_taken'=>$taking_time,'ts'=>$ts]
        );
        $resp = array('status'=>'success');
        echo json_encode($resp);
    }

    public function PauseTestApi(Request $req){

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');   

        $data = PaperStatusTable::updateOrCreate(
            ['email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id],
            ['email_id'=>$req->email_id,'exam_mode_id'=>$req->exam_mode_id,'test_series_id'=>$req->test_series_id,'paper_code'=>$req->paper_code,'status'=>0,'remaining_time'=>$req->rTem,'pause_question'=>$req->pause_question,'ts'=>$ts]
        );
    }

    public function pauseQuestionApi(Request $req){
        $data = PaperStatusTable::where('email_id',$req->email_id)->where('paper_code',$req->paper_code)->where('exam_mode_id',$req->exam_mode_id)->where('test_series_id',$req->test_series_id)->first();
        if($data === null){
            $pause_question = 1;
        }else{
            $pause_question = $data->pause_question;
        }
        $match = array('pause_question'=>$pause_question);

        echo json_encode($match);
    }
}
