<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

use App\Models\User;

use App\Models\AnswerListModel;

use App\Models\PaperStatusTable;

use App\Models\PaperCodeDetails;

use App\Models\RegisteredUser;  

use App\Models\StudentRegisterModel;

use Illuminate\Support\Facades\Hash;

use DB;

class TestseriesController extends Controller
{
    //login authentication
    function Login(Request $request)
    {
        $user= User::where('email', $request->email)->first();
            if (!$user || !Hash::check($request->password, $user->password)) {
                return response([
                    'message' => ['These credentials do not match our records.']
                ], 404);
            }

            $token = $user->createToken('my-app-token')->plainTextToken;

            $response = [
                'user' => $user,
                'token' => $token
            ];

            return response($response, 201);
    }

    //all data
    public function index(Request $req)
    {
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';

        if($exam_mode_id == 1){
            $table = 'full_test_table';
        }else if($exam_mode_id == 2){
            $table = 'subject_test_table';     
        }else if($exam_mode_id == 3){
            $table = 'chapter_test_table';
        }else{
            $table = 'previous_test_table';
        }

       try{
        $sb_data = DB::table($table)->where('paper_code',$paper_code)->groupBy('subject_id')->orderBy('paper_id','ASC')->get();
        $ar = array();
        foreach($sb_data as $sb){
            $subj_id = $sb->subject_id;
            $ppr_id = $sb->paper_id;

            $subject_data = DB::table('subject_master_table')->where('id',$subj_id)->first();
            $subject_name = $subject_data->subject_name;

            $ar[] = array('sb_id'=>$subj_id,'ppr_id'=>$ppr_id,'subject_name'=>$subject_name);
        }

        $data = DB::table($table)->where('paper_code',$paper_code)->get();

        foreach($data as $query){
        $paper_id = $query->paper_id;
        $question_id = $query->question_id;
        $subject_id = $query->subject_id;
        $positive_marks = $query->marks;
        $negative_marks = $query->minus_marking;
        $hindi_question = ($query->hindi_question);
        $hindi_option1 = ($query->option1_hindi);
        $hindi_option2 = ($query->option2_hindi);
        $hindi_option3 = ($query->option3_hindi);
        $hindi_option4 = ($query->option4_hindi);
        $eng_question = ($query->eng_question);            
        $option1 = ($query->option1);
        $option2 = ($query->option2);
        $option3 = ($query->option3);   
        $option4 = ($query->option4);                    

        $answer_data = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->where('question_no',$paper_id)->first();

        if($answer_data === null){
            $answered_ques = 0;
            $answer = 0;
            $hrs = 0;
            $mins = 0;
            $secs = 1;
        }else{
            $ans_status = $answer_data->answer_status;
            $answer_time = $answer_data->answer_time;
            $answer = $answer_data->answer;
            $timesplit=explode(':',$answer_time);
            $hrs = $timesplit[0];
            $mins = $timesplit[1];
            $secs = $timesplit[2];

            if($ans_status == 1){
                $answered_ques = 1;
            }else if($ans_status == 2){
                $answered_ques = 2;
            }else if($ans_status == 3){
                $answered_ques = 3;
            }else if($ans_status == 4){
                $answered_ques = 4; 
            }else{
                $answered_ques = 4;
            }
        }

        $response[] = array('qid'=>$paper_id,'question_id'=>$question_id,'subject_id'=>$subject_id,'question'=>$eng_question,'option1'=>$option1,'option2'=>$option2,'option3'=>$option3,'option4'=>$option4,'hindi_question'=>$hindi_question,'hindi_option1'=>$hindi_option1,'hindi_option2'=>$hindi_option2,'hindi_option3'=>$hindi_option3,'hindi_option4'=>$hindi_option4,'positive_marks'=>$positive_marks,'negative_marks'=>$negative_marks,'answered_ques'=>$answered_ques,'hrs'=>$hrs,'mins'=>$mins,'secs'=>$secs,'answer'=>$answer);
        }

        $resp[] = array('subjects'=>$ar,'details'=>$response);

       }catch(Exception $e){
        return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
       }
       echo json_encode($resp);
    }

    //save next

    public function SaveNextApi(Request $req)
    {
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $paper_id = isset($req['paper_id'])?$req['paper_id']:'';
        $option = isset($req['option'])?$req['option']:'';
        $answer_status = isset($req['answer_status'])?$req['answer_status']:'';
        $email_id = isset($req['email_id'])?$req['email_id']:'';
        $SingleTm = isset($req['SingleTm'])?$req['SingleTm']:'';
        $rTem = isset($req['rTem'])?$req['rTem']:'';
        $test_series_id = isset($req['test_series_id'])?$req['test_series_id']:'';
        $exam_mode_id = isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $subject = isset($req['subject'])?$req['subject']:'';
        $CurrentPaperId = isset($req['CurrentPaperId'])?$req['CurrentPaperId']:'';
        $SaveType = isset($req['SaveType'])?$req['SaveType']:'';

        if($answer_status == '1' && $option !=''){
            $answer_status = 1;
        }else if($answer_status == '1' && $option ==''){
            $answer_status = 2;
        }else if($answer_status == '4' && $option ==''){
            $answer_status = 3;
        }else if($answer_status == '4' && $option !=''){
            $answer_status = 4;
        }else if($answer_status == '5' && $option ==''){
            $answer_status = 2;
        }else if($answer_status == '5' && $option !=''){
            $answer_status = 1;
        }

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');

       try{

        if($exam_mode_id == 1){
            $table = 'full_test_table';
        }else if($exam_mode_id == 2){
            $table = 'subject_test_table';
        }else if($exam_mode_id == 3){
            $table = 'chapter_test_table';
        }else{
            $table = 'previous_test_table';
        }

        $corr_data = DB::table($table)->where('paper_code',$paper_code)->where('paper_id',$paper_id)->first();
        $correct_answer = $corr_data->correct_answer;
        
        if($SaveType == 'nxt'){
            $data = AnswerListModel::updateOrCreate(
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'question_no'=>$paper_id,'exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id],
                ['exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id,'subject_id'=>$subject,'email_id'=>$email_id,'paper_code'=>$paper_code,'question_no'=>$paper_id,'answer'=>"$option",'correct_answer'=>$correct_answer, 'answer_status'=>$answer_status,'answer_time'=>$SingleTm,'time'=>$ts]
            );
        }else{
            $data = AnswerListModel::updateOrCreate(
                ['email_id'=>$email_id,'paper_code'=>$paper_code,'question_no'=>$paper_id,'exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id],
                ['exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id,'subject_id'=>$subject,'email_id'=>$email_id,'paper_code'=>$paper_code,'question_no'=>$paper_id,'correct_answer'=>$correct_answer,'answer_time'=>$SingleTm,'time'=>$ts]
            );
        }
        $data = PaperStatusTable::updateOrCreate(
            ['email_id'=>$email_id,'paper_code'=>$paper_code,'exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id],
            ['email_id'=>$email_id,'exam_mode_id'=>$exam_mode_id,'test_series_id'=>$test_series_id,'paper_code'=>$paper_code,'status'=>0,'remaining_time'=>$rTem,'pause_question'=>$paper_id,'ts'=>$ts]
        );

        $s_data_count = DB::table($table)->where('paper_code',$paper_code)->count();

        if($paper_id == $s_data_count){
            $s_data = DB::table($table)->where('paper_code',$paper_code)->where('paper_id',$paper_id)->first();
        }else{
           $s_data = DB::table($table)->where('paper_code',$paper_code)->where('paper_id',$paper_id+1)->first();
        }
        $sub_id = $s_data->subject_id;
   
        $answered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->whereIN('answer_status',[1,4])->count();

        $notanswered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->whereIN('answer_status',[2,3])->count();

        $marked_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->where('answer_status',3)->count();

        $marked_answered_count = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->where('answer_status',4)->count();

        $total_answered = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->count();

        $paper_count = PaperCodeDetails::where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->first();
        $questions = $paper_count->questions;

        $not_visited = $questions - $total_answered;

        $subject_sql = DB::table('subject_master_table')->where('id',$sub_id)->first();
        $subjectname = $subject_sql->subject_name;

        $answered_check = AnswerListModel::where('paper_code',$paper_code)->where('email_id',$email_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->where('question_no',$CurrentPaperId)->whereIN('answer_status',[1,4])->first();
        if($answered_check != null){
            $choosed_answer = $answered_check->answer;
        }else{
            $choosed_answer = '';
        }

        $response = array('sub_id'=>$sub_id,'answer_status'=>$answer_status,'answered_count'=>$answered_count,'notanswered_count'=>$notanswered_count,'marked_count'=>$marked_count,'marked_answered_count'=>$marked_answered_count,'not_visited'=>$not_visited,'paper_ids'=>$paper_id,'status'=>1,'subjectname'=>$subjectname,'choosed_answer'=>$choosed_answer);

       }catch(Exception $e){
        return response()->JSON(['error'=> trans('api.something_went_wrong')], 500);
       }
       echo json_encode($response); 
    }
 
    //save single time
    public function SaveSingleTimeApi(Request $req){

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');

        $data = AnswerListModel::updateOrCreate(
            ['email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'question_no'=>$req->paper_id],
            ['exam_mode_id'=>1,'test_series_id'=>1,'email_id'=>$req->email_id,'paper_code'=>$req->paper_code,'question_no'=>$req->paper_id,'answer_time'=>$req->tTem,'time'=>$ts]
        );
    }

    //pause details

    public function AnswerDetailsApi(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id =  isset($req['email_id'])?$req['email_id']:'';
        $exam_mode_id =  isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $test_series_id =  isset($req['test_series_id'])?$req['test_series_id']:'';

        if($exam_mode_id == 1){
            $table = 'full_test_table';
        }else if($exam_mode_id == 2){
            $table = 'subject_test_table';
        }else if($exam_mode_id == 3){
            $table = 'chapter_test_table';
        }else{
            $table = 'previous_test_table';
        }

        $sb_query = DB::table($table)->where('paper_code',$paper_code)->groupBy('subject_id')->orderBy('paper_id','ASC')->get();
 
        foreach($sb_query as $sb){

        $sub_id = $sb->subject_id;

        $sbname_query = DB::table('subject_master_table')->where('id',$sub_id)->first();

        $subject_name = $sbname_query->subject_name;

        $answered_count = AnswerListModel::where('paper_code',$paper_code)
        ->where('subject_id',$sub_id)
        ->where('email_id',$email_id)
        ->where('exam_mode_id',$exam_mode_id)
        ->where('test_series_id',$test_series_id)
        ->whereIN('answer_status',[1,4])
        ->count();  

        $notanswered_count = AnswerListModel::where('paper_code',$paper_code)
        ->where('subject_id',$sub_id)
        ->where('email_id',$email_id)
        ->where('exam_mode_id',$exam_mode_id)
        ->where('test_series_id',$test_series_id)
        ->whereIN('answer_status',[2,3])
        ->count();  

        $marked_answered_count = AnswerListModel::where('paper_code',$paper_code)
        ->where('subject_id',$sub_id)
        ->where('email_id',$email_id)
        ->where('exam_mode_id',$exam_mode_id)
        ->where('test_series_id',$test_series_id)
        ->where('answer_status',4)
        ->count();

        $questions = DB::table($table)->where('paper_code',$paper_code)->where('subject_id',$sub_id)->count();

        $stq = $answered_count + $notanswered_count;

        $not_visited = $questions - $stq;
        $response[] = array('subject_name'=>$subject_name,'answered'=>$answered_count,'notanswered_count'=>$notanswered_count,'marked_answered_count'=>$marked_answered_count,'not_visited'=>$not_visited,'questions'=>$questions);
        }
        return response($response);
    }

    public function clearResponseApi(Request $req){
        $paper_code =  isset($req['paper_code'])?$req['paper_code']:'';
        $email_id =  isset($req['email_id'])?$req['email_id']:'';
        $exam_mode_id =  isset($req['exam_mode_id'])?$req['exam_mode_id']:'';
        $test_series_id =  isset($req['test_series_id'])?$req['test_series_id']:'';
        $paper_id =  isset($req['paper_id'])?$req['paper_id']:'';

        date_default_timezone_set('asia/kolkata');
	    $ts = date('y-m-d h:i:s');   

        $data = AnswerListModel::where('email_id',$email_id)->where('paper_code',$paper_code)->where('question_no',$paper_id)->where('exam_mode_id',$exam_mode_id)->where('test_series_id',$test_series_id)->update(['answer'=>'','answer_status'=>'2','time'=>$ts]);
    }

    public function testSeriesNameApi(Request $req){
        $test_series_id =  isset($req['test_series_id'])?$req['test_series_id']:'';

        $data = DB::table('test_series_name')->where('id',$test_series_id)->first();

        if($data !== null){
            $testseriesname = $data->test_series_name;
        }else{
            $testseriesname = '';
        }

        $match = array('test_series_name'=>$testseriesname);

        echo json_encode($match);
    } 

    public function LiveTestResultApi(Request $req){
        $email_id =  isset($req->email_id)?$req->email_id:'';
        $paper_code =  isset($req->paper_code)?$req->paper_code:'';
        $test_series_id =  isset($req->test_series_id)?$req->test_series_id:'';
        $exam_mode_id =  isset($req->exam_mode_id)?$req->exam_mode_id:'';

        date_default_timezone_set('asia/kolkata');
        $current_date = date('Y-m-d');
        $currentTime = date('H:i:s');

        $data = PaperStatusTable::where('email_id',$email_id)->where('paper_code',$paper_code)->where('test_series_id',$test_series_id)->where('exam_mode_id',$exam_mode_id)->first();

        if($data != null){
            $paper_details = PaperCodeDetails::where('paper_code',$paper_code)->where('exam_mode_id',$exam_mode_id)->first();
            $start_date = $paper_details->end_date;
            $end_time = $paper_details->end_time;
            $test_title = $paper_details->test_title;

            $expired_time = date('h:i A', strtotime($end_time));

            $expired_date = date('d F, Y', strtotime($start_date));

            $paper_details_ar = array('test_title'=>$test_title,'expired_date'=>$expired_date,'expired_time'=>$expired_time);
        }else{
           
            $paper_details_ar = array();
        }

        $upcoming_test = DB::table('paper_code_master_table')->where('test_type','live')->where('start_date','>=',$current_date)->get();

        foreach($upcoming_test as $upcoming_row){
            $paper_code = $upcoming_row->paper_code;
            $exam_mode_id = $upcoming_row->exam_mode_id;
            $start_date = $upcoming_row->start_date;
            $start_time = $upcoming_row->start_time;
            $end_date = $upcoming_row->end_date;
            $end_time = $upcoming_row->end_time;
            $questions = $upcoming_row->questions;
            $time = $upcoming_row->time;
            $marks = $upcoming_row->marks;
            $test_title = $upcoming_row->test_title;

            $test_start_time = date('h:i A', strtotime($start_time));

            $test_start_date = date('d F, Y', strtotime($start_date));

            $check_user = RegisteredUser::where('email_id',$email_id)->where('paper_code',$paper_code)->first();
            if($check_user === null){
                $registered_user = '0';
            }else{
                $registered_user = '1';
            }

            $check_student = StudentRegisterModel::where('email_id',$email_id)->first();
            if($check_student === null){
                $registered_std = '0';
            }else{
                $registered_std = '1';
            }

            $test_series_data = DB::table('test_series_package_table')->where('exam_mode_id',$exam_mode_id)->where('paper_code',$paper_code)->first();
            if($test_series_data !== null){
                $test_series_id = $test_series_data->test_series_id;
            }else{
                $test_series_id = '';
            }

            if($start_date == $current_date){
                if($start_time > $currentTime){
                    $upcoming_ar[] = array('paper_code'=>$paper_code,'start_date'=>$test_start_date,'start_time'=>$test_start_time,'test_title'=>$test_title,'registered_std'=>$registered_std,'registered_user'=>$registered_user,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id);
                }
            }else{
                $upcoming_ar[] = array('paper_code'=>$paper_code,'start_date'=>$test_start_date,'start_time'=>$test_start_time,'test_title'=>$test_title,'registered_std'=>$registered_std,'registered_user'=>$registered_user,'test_series_id'=>$test_series_id,'exam_mode_id'=>$exam_mode_id);
            }
        }

        if(empty($upcoming_ar)){
            $upcoming_ar = array();
        }

        $match = array('liveResult'=>$paper_details_ar,'upcomingTest'=>$upcoming_ar);

        echo json_encode($match);
    }
}
       