import './App.css';
import Header1 from './Header1';
import { Row, Col } from 'react-bootstrap'
import { Link, useNavigate } from 'react-router-dom';
import { BiStar } from "react-icons/bi";
import { FaStar } from "react-icons/fa";
import React, { useState, useEffect } from 'react';
import { useCookies } from 'react-cookie'
import Cartlistdata from './Cartlistdata'
import Footer from './Footer'

function Cartlist() {
    const [cookies] = useCookies();
    const [result, setResult] = useState([]);   
    const [tprice, setTprice] = useState([]);
    const [itemcount, setTotalitem] = useState([]);
    const [status, setStatus] = useState([]);
    const [savelist, setSavelater] = useState([]);
    const [saveditem, setSaveditem] = useState([]);
    const [savedstatus, setSavedStatus] = useState([]);
    const [popular, setPopular] = useState([]);
    const navigate = useNavigate();

    

    useEffect(() => {
        cart();
    }, [])

    async function cart() {
        let email_id = { 'email_id': cookies.user }
        let res = await fetch("http://65.1.43.157/laravel/public/api/listcart", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(email_id)
        })
        res = await res.json();
        console.log(res)
        setResult(res);
        setTprice(res[0].total_price);
        setTotalitem(res[0].total_count);
        setStatus(res[0].status);
    }


    async function deleteFun(e) {
        let bookid = { 'bookid': e.target.id, 'email_id': cookies.user }
		console.log(bookid)  
        await fetch("http://65.1.43.157/laravel/public/api/deletecart", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(bookid)
        });
        cart();
        savelaterlist();
    }
	
	async function SaveLaterdeleteFun(e) {
        let bookid = { 'bookid': e.target.id, 'email_id': cookies.user }
		console.log(bookid)  
        await fetch("http://65.1.43.157/laravel/public/api/deletesaveforlater", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(bookid)
        });
        cart();
        savelaterlist();
    }

    async function saveLater(e) {
        let bookid = { 'bookid': e.target.id,'email_id':cookies.user }
        let del_result = await fetch("http://65.1.43.157/laravel/public/api/saveforlater", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(bookid)
        });
        del_result = await del_result.json();
        cart();
        savelaterlist();
    }
   
    async function savelaterlist() {
        let email_id = { 'email_id': cookies.user }
        let save_res = await fetch("http://65.1.43.157/laravel/public/api/saveforlaterlist", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(email_id)
        }) 
        save_res = await save_res.json();
        setSavelater(save_res);
        setSaveditem(save_res[0].saved_item);
        setSavedStatus(save_res[0].status);
        console.log(save_res[0].status)
    }

    useEffect(() => {
        savelaterlist();
    }, [])

    async function fromsavetoadd(e) {
        let bookid = { 'bookid': e.target.id, 'email_id': cookies.user }
        let save_to_add = await fetch("http://65.1.43.157/laravel/public/api/fromsavetoadd", {
            method: 'POST',
            headers: {
                "Content-Type": "application/json",
                "Accept": "application/json"
            },
            body: JSON.stringify(bookid)
        });
        save_to_add = await save_to_add.json(); 
        cart(); 
        savelaterlist();
    }

    useEffect(async () => {
        let popular_result = await fetch("http://65.1.43.157/laravel/public/api/popularBook");
        popular_result = await popular_result.json();
        setPopular(popular_result);
    }, [])

    function buyFun() {
        navigate('/billing_address')
    }


    return (
        <>
            <Header1 />
            <div className='row cartdiv'>
                <div className='col-md-9'>
                    {
                        status == 0 ? <Row><Col><h2 style={{ marginTop: '10%' }}>Your Cart is Empty !!!</h2></Col></Row> :
                            <div className='row'>
                                <div className='row cart-header'>
                                    <div className='cart-header-absolute'>
                                        <p>Bulk Order Cart</p>
                                    </div>
                                </div>
                                {
                                    result.map((item) => {
                                        return <Cartlistdata key={item.bookid} {...item} dataa={cart} dltFun={deleteFun} saveLtr={saveLater} />
                                    }
                                    )
                                }
                                <div className='row total-price'>
                                    <p>Subtotal ({itemcount} items): <span>Rs {tprice}</span></p>
                                </div>
                            </div>
                    }
                    {
                        savedstatus == 0 ? '' :
                            <div className='row save-for-later'>
                                <h2>Saved for later ({saveditem} items)</h2>
                                {
                                    savelist.map((saveitem) =>
                                        <div className='col-md-3' style={{ marginTop: '3%' }} key={saveitem.bookid}>
                                            <img src={saveitem.book_image_path} alt='img' />
                                            <p>{saveitem.book_title}</p>
                                            <button className='save-cart' onClick={fromsavetoadd} id={saveitem.bookid}>Add to cart</button>
                                            <button className='del-btn' onClick={SaveLaterdeleteFun} id={saveitem.bookid}>Delete</button>
                                        </div>
                                    )}
                            </div>
                    }
                </div>


                <div className='col-md-3'>
                    <div className='row protection-div'>
                        <img src='https://images-eu.ssl-images-amazon.com/images/G/31/checkout/assets/TM_desktop._CB443006202_.png' alt='protection' />
                    </div>
                    <div className='row proceed-item'>
                        <p>Subtotal ({itemcount} items): <span style={{ fontWeight: '500' }}>Rs {tprice}</span></p>
                        <button className='buy-from-cart' onClick={buyFun}>Proceed to buy</button>
                    </div>
                    <div className='row popolar-item'>
                        <h6>Most popular items</h6>
                        {
                            popular.map((plr) =>
                                <div className='popolar-added-item' key={plr.book_id}>
                                    <div className='col-md-2'>
                                        <img src={plr.book_image_path} alt='img' />
                                    </div>
                                    <div className='col-md-10 popolar-added-item-text'>
                                        <Link to={"/bookdetails/" + plr.book_id}>{plr.book_title}</Link>
                                        <p>Baljiy Dhaka Sir</p>
                                        <p><span className='popular-start1'><FaStar /></span>
                                            <span className='popular-start1'><FaStar /></span>
                                            <span className='popular-start1'><FaStar /></span>
                                            <span className='popular-start1'><FaStar /></span>
                                            <span className='popular-start2'><BiStar /></span>
                                        </p>
                                        <p>Paperback</p>
                                        <p style={{ color: 'red' }}>Rs {plr.book_price}</p>
                                        {/* <button className='popular-addcart' value={item.bookid} onChange={addToCart}>Add to cart</button> */}
                                    </div>
                                </div>
                            )}
                    </div>
                </div>
            </div>
			<Footer />
        </>
    )
}
export default Cartlist;