<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\productController;
use App\Http\Controllers\LoginController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\RegisterController;
use App\Http\Controllers\otpController;
use App\Http\Controllers\CatalogueController;
use App\Http\Controllers\TestSeriesInfoController;
use App\Http\Controllers\TestseriesController;
use App\Http\Controllers\PaperCodeDetailsController;
use App\Http\Controllers\AttemptedController;
use App\Http\Controllers\SubmitTestController;
use App\Http\Controllers\ReportController;
use App\Http\Controllers\SolutionController;    
use App\Http\Controllers\AdminController;

/* 
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| is assigned the "api" middleware group. Enjoy building your API!
|
*/

// Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    // return $request->user();
// });
Route::group(['middleware' => 'auth:sanctum'], function(){
    //All secure URL's
    Route::get('index',[productController::class,'ap']);
	Route::delete('del/{id}',[productController::class,'delt']);
	Route::put('update/{id}',[productController::class,'update']);
	Route::post('login',[LoginController::class,'loginApi']);
	Route::post('examApi',[TestSeriesInfoController::class,'ExamInfoApi']);
	Route::post('examWebApi',[TestSeriesInfoController::class,'ExamWebInfoApi']);
	Route::post('resumeInfo',[TestSeriesInfoController::class,'resumeInfoApi']);
	Route::post('LiveTest',[TestSeriesInfoController::class,'LiveTestApi']);
	Route::post('OtherTestSeries',[TestSeriesInfoController::class,'OtherTestSeriesApi']);
	Route::post('FreeTests',[TestSeriesInfoController::class,'FreeTestsApi']);
	Route::post('FreeTestsWeb',[TestSeriesInfoController::class,'FreeTestsWebApi']);
	Route::post('NewTestsWeb',[TestSeriesInfoController::class,'NewTestsWebApi']);
	Route::post('ExamTier',[TestSeriesInfoController::class,'ExamTierApi']);
	Route::post('SpecificExam',[TestSeriesInfoController::class,'SpecificExamApi']);
	Route::post('RelatedExam',[TestSeriesInfoController::class,'RelatedExamApi']);
	Route::post('TestSeries',[TestSeriesInfoController::class,'TestSeriesApi']);                                
	Route::post('TestSeriesDetails',[TestSeriesInfoController::class,'TestSeriesDetailsApi']);
    Route::post('Breadcrump',[TestSeriesInfoController::class,'BreadcrumpApi']);
    Route::post('teatDetails',[TestSeriesInfoController::class,'teatDetailsApi']);     
    Route::post('TestSeriesDetailsTest',[TestSeriesInfoController::class,'TestSeriesDetailsTestApi']);                                  
	Route::post('testSeriesAccess',[TestSeriesInfoController::class,'testSeriesAccessApi']);                     
	Route::post('MegaMockChallenge',[TestSeriesInfoController::class,'MegaMockChallengeApi']);
	Route::post('MegaMockChallengeTest',[TestSeriesInfoController::class,'MegaMockChallengeTestApi']);
	Route::post('testMarkDetails',[TestSeriesInfoController::class,'testMarkDetailsApi']);
	Route::get('Trending',[TestSeriesInfoController::class,'TrendingAPi']);
    Route::post('index',[TestseriesController::class,'index']);
    Route::post('save_next',[TestseriesController::class,'SaveNextApi']);
    Route::post('answerDetails',[TestseriesController::class,'AnswerDetailsApi']);
    Route::post('testName',[TestSeriesInfoController::class,'testNameApi']);
    Route::post('save_single_time',[TestseriesController::class,'SaveSingleTimeApi']);
    Route::post('paperCodeDetails',[PaperCodeDetailsController::class,'PaperCodeDetailsApi']);
    Route::post('attempted',[AttemptedController::class,'Attempted']);   
    Route::post('updateAns',[AttemptedController::class,'UpdateAnswer']);
    Route::post('submit',[SubmitTestController::class,'SubmitTest']);
    Route::post('pauseTest',[SubmitTestController::class,'PauseTestApi']); 
    Route::post('pauseQuestion',[SubmitTestController::class,'pauseQuestionApi']);
    Route::post('report',[ReportController::class,'Report']); 
    Route::post('solution',[SolutionController::class,'Solution']);
    Route::post('bookmark',[SolutionController::class,'BookmarkApi']); 
    Route::post('next',[SolutionController::class,'NextApi']);
    Route::post('rating',[SolutionController::class,'RatingApi']);
    Route::post('studentInfo',[TestSeriesInfoController::class,'StudentInfoApi']);
    Route::post('checkregistration',[TestSeriesInfoController::class,'CheckregistrationApi']);
    Route::post('LiveTestCount',[TestSeriesInfoController::class,'LiveTestCountApi']);
    Route::get('TestPassDetails',[TestSeriesInfoController::class,'TestPassDetailsApi']);
    Route::post('clearResponse',[TestseriesController::class,'clearResponseApi']);
    Route::post('testSeriesName',[TestseriesController::class,'testSeriesNameApi']);
    Route::post('LiveTestResult',[TestseriesController::class,'LiveTestResultApi']);
    Route::get('ExamInfoWeb',[TestSeriesInfoController::class,'ExamInfoWebApi']);
    Route::post('SpecificExamWeb',[TestSeriesInfoController::class,'SpecificExamWebApi']);
    Route::post('otp',[otpController::class,'otpApi']);
    Route::post('AttemptedTest',[AttemptedController::class,'AttemptedTestApi']);
});                                
    
Route::post('loginbyauth',[UserController::class,'index']);            
Route::post('register',[RegisterController::class,'RegisterApi']);
Route::post('otp',[otpController::class,'otpApi']);         
Route::get('exams',[CatalogueController::class,'examName']);           
Route::post('addcart',[CatalogueController::class,'addCartApi']);         
Route::post('booksdetils',[CatalogueController::class,'bookDataApi']);
Route::get('cart',[CatalogueController::class,'CartApi']);
Route::post('addedcart',[CatalogueController::class,'AddedCartApi']);
Route::get('listcart',[CatalogueController::class,'listcartApi']);
Route::post('deletecart',[CatalogueController::class,'DeleteCartApi']);
Route::post('saveforlater',[CatalogueController::class,'SaveForLaterCartApi']);
Route::get('saveforlaterlist',[CatalogueController::class,'savelaterlistApi']);
Route::post('fromsavetoadd',[CatalogueController::class,'savetoaddApi']);
Route::get('popularBook',[CatalogueController::class,'popularBookApi']);
Route::post('bookdetailed',[CatalogueController::class,'BookDetailedApi']);
Route::post('addwishcart',[CatalogueController::class,'addWishListApi']);
Route::post('addedwishlist',[CatalogueController::class,'addedWishListApi']);
Route::post('wishlisting',[CatalogueController::class,'WishListingApi']);
Route::post('adminlogin',[AdminController::class,'AdminLogin']);
Route::post('orders',[AdminController::class,'OrderApi']);
